#pragma semicolon 1

#include <ws_store>
#include <sourcemod>

public Plugin:myinfo = 
{
	name	= "STORE (RegenHP)",
	author	= "Tokami (World-Source.Ru)",
	version = "1.2"
};

new g_Price, g_CategoryID, g_ItemID;
new Float:g_fTimerRegen;
new g_iRegen;
new g_iRegenMax;
new Handle:g_Timer[MAXPLAYERS+1];

new iBuyRegen[MAXPLAYERS+1];

public OnPluginStart()
{
	CreateTimer(1.0, START);
	HookEvent("player_spawn",	player_spawn);
	HookEvent("player_hurt",	player_hurt);
}

public OnPluginEnd()
{
	if (g_CategoryID > 0 && !STORE_DeleteCategoryByID(g_CategoryID, true) && g_ItemID > 0)
		STORE_RemoveItemFromCategory(g_CategoryID, g_ItemID);
}

public STORE_Loaded()
{
	g_CategoryID = 0; g_ItemID = 0;
	decl String:PluginName[150]; PluginName[0] = '\0'; GetPluginFilename(GetMyHandle(), PluginName, 150);
	ServerCommand("sm plugins reload \"%s\"", PluginName);
}

public Action:START(Handle:timer)
{
	/////
	new Handle:kv = CreateKeyValues("store_regen_hp");

	if (!FileToKeyValues(kv, "cfg/store/modules/store_regen_hp.txt"))
		SetFailState("Error in cfg/store/modules/store_regen_hp.txt");

	decl String:CategoryName[STORE_CATEGORY_LENGTH];
	KvGetString(kv, "CategoryName", CategoryName, STORE_CATEGORY_LENGTH);
	if (TrimString(CategoryName) < 1)
		SetFailState("Категория не указана");

	new bool:bCategoryExist = (g_CategoryID = STORE_GetCategoryID(CategoryName)) > 0;
	decl String:Text[STORE_ITEMTEXT_LENGTH], String:str_flag[10];

	if (!bCategoryExist)
	{
		KvGetString(kv, "CategoryText", Text, STORE_ITEMTEXT_LENGTH);
		KvGetString(kv, "CategoryFlag", str_flag, 10);

		if ((g_CategoryID = STORE_CreateCategory(CategoryName, Text, str_flag)) < 1)
			SetFailState("Не удалось создать категорию '%s'", CategoryName);
	}

	g_Price = KvGetNum(kv, "price");
	
	if ((g_iRegen = KvGetNum(kv, "regen_hp")) <= 1) g_iRegen = 1;
	if ((g_iRegenMax = KvGetNum(kv, "regen_hp_max")) <= 100) g_iRegenMax = 100;
	if ((g_fTimerRegen = KvGetFloat(kv, "regen_timer")) <= 1.0) g_fTimerRegen = 1.0;

	KvGetString(kv, "ItemText", Text, STORE_ITEMTEXT_LENGTH);
	if (TrimString(Text) > 0)
	{
		KvGetString(kv, "ItemFlag", str_flag, 10);
		if ((g_ItemID = STORE_AddItemToCategory(g_CategoryID, Text, g_Price, true, MyCallBack, str_flag)) < 1)
		{
			if (!bCategoryExist)
			{
				STORE_DeleteCategoryByID(g_CategoryID, true);
				g_CategoryID = 0;
			}
			SetFailState("Не удалось добавить функцию '%s'", Text);
		}
	}
	else if (bCategoryExist)
		SetFailState("Укажите уникальное название категории или используйте ItemText");

	CloseHandle(kv);
	/////

	return Plugin_Stop;
}

public MyCallBack(client, const String:steamid[], CategoryID, ItemID, ItemPrice)
{
	if (ItemID == g_ItemID)
		wS_OnClientSelect(client, LastMenuItem:MI_InCategory);
}

public STORE_OnClientSelectEmptyCategory(client, const String:steamid[], CategoryID)
{
	if (CategoryID == g_CategoryID)
		wS_OnClientSelect(client, LastMenuItem:MI_Main);
}

stock wS_OnClientSelect(client, LastMenuItem:MI)
{
	if (!IsPlayerAlive(client))
	{
		PrintCenterText(client, "Вы должны быть живы");
		STORE_ShowMenu(client, MI);
		return;
	}

	if (iBuyRegen[client])
	{
		PrintCenterText(client, "У вас уже куплена регинерация");
		STORE_ShowMenu(client, MI);
		return;
	}

	if (g_Price > 0)
	{
		new credits = STORE_GetCredits(client);

		if (credits < g_Price)
		{
			PrintCenterText(client, "Вам не хватает %d кр", (g_Price - credits));
			STORE_ShowMenu(client, MI);
			return;
		}

		if (!STORE_SetCredits(client, (credits - g_Price)))
		{
			LogError("Не удалось установить кредиты игроку '%N'", client);
			return;
		}
	}

	iBuyRegen[client] = true;
	STORE_ShowMenu(client, MI);
}

public player_spawn(Handle:event, const String:name[], bool:silent)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	if(iBuyRegen[client])
	{
		wS_KillTimer(client);
	}
}

public OnClientDisconnect(client)
{
	if(iBuyRegen[client])
	{
		wS_KillTimer(client);
	}
}

wS_KillTimer(client)
{
	if (g_Timer[client] != INVALID_HANDLE)
	{
		KillTimer(g_Timer[client]);
		g_Timer[client] = INVALID_HANDLE;
	}
}

public player_hurt(Handle:event, const String:name[], bool:silent)
{
	if (GetEventInt(event, "health") < 1)
		return;

	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	if(iBuyRegen[client])
	{
		if (g_Timer[client] != INVALID_HANDLE)
			return;

		g_Timer[client] = CreateTimer(g_fTimerRegen, RegenHP, client, TIMER_REPEAT);
	}
}

public Action:RegenHP(Handle:timer, any:client)
{
	if (IsPlayerAlive(client) && iBuyRegen[client])
	{
		new hp = GetEntProp(client, Prop_Send, "m_iHealth");
		if (hp < g_iRegenMax)
		{
			hp += g_iRegen;
			if (hp > g_iRegenMax) hp = g_iRegenMax;
			SetEntProp(client, Prop_Send, "m_iHealth", hp);
			if (hp < g_iRegenMax) return Plugin_Continue;
		}
	}
	g_Timer[client] = INVALID_HANDLE;
	return Plugin_Stop;
}